################################################################################
#
# System:  "2P32M"
# Machine: ""
# Type: LASER  2.5
# version xx.xx.xx ()
# Russia, KnAAPO,OGT,SPC(Sector of the Program Control,#"  ")
# Author's : Rodionova Elena.
#
################################################################################
#   	Date        		Who           		Reason#
# 10-11 --2004   Rodionova            0. Original
#						  1.    ( G09,     )
#                                                       USER DEFINED  SLOWDN/angle[,maxfeed]
#
# $HISTORY$
################################################################################

  global flagCutcom_begin ; set flagCutcom_begin  0

  set cam_post_dir  [MOM_ask_env_var UGII_CAM_POST_DIR]
  set cam_debug_dir [MOM_ask_env_var UGII_CAM_DEBUG_DIR]

proc MOM_before_each_add_var {} {}
proc MOM_before_each_event {} {}

#source ${cam_debug_dir}mom_review.tcl
  MOM_set_debug_mode OFF

#_______________________________________________________________________________
#The following command invokes the warning mode and the default settings.
#_______________________________________________________________________________
  source ${cam_post_dir}/ugpost_base.tcl

 if { ![info exists mom_sys_post_initialized] } {

########## SYSTEM VARIABLE DECLARATIONS ##############
  set mom_sys_rapid_code                        "1"
  set mom_sys_linear_code                       "1"
  set mom_sys_circle_code(CLW)                  "2"
  set mom_sys_circle_code(CCLW)                 "3"
  set mom_sys_delay_code(SECONDS)               "4"
  set mom_sys_delay_code(REVOLUTIONS)           "4"
  set mom_sys_cutcom_plane_code(XY)             "17"
  set mom_sys_cutcom_plane_code(ZX)             "18"
  set mom_sys_cutcom_plane_code(YZ)             "19"
  set mom_sys_cutcom_code(OFF)                  "40"
  set mom_sys_cutcom_code(LEFT)                 "41"
  set mom_sys_cutcom_code(RIGHT)                "42"
  set mom_sys_adjust_code(PLUS)                 "43"
  set mom_sys_adjust_code(MINUS)                "44"
  set mom_sys_adjust_code(OFF)                  "40"
#
  set mom_sys_output_code(ABSOLUTE)             "90"
  set mom_sys_output_code(INCREMENTAL)          "91"
  set mom_sys_reset_code                        "28"
  set mom_sys_return_code                       "26"
  set mom_sys_program_stop_code                 "0"
  set mom_sys_optional_stop_code                "1"
  set mom_sys_end_of_program_code               "2"
#
set mom_sys_end_of_subprogram_code              "17"
#
  set mom_sys_spindle_direction_code(CLW)       "3"
  set mom_sys_spindle_direction_code(CCLW)      "4"
  set mom_sys_spindle_direction_code(OFF)       "5"
  set mom_sys_tool_change_code                  "6"
  set mom_sys_coolant_code(MIST)                "7"
  set mom_sys_coolant_code(ON)                  "8"
  set mom_sys_coolant_code(FLOOD)               "8"
  set mom_sys_coolant_code(TAP)                 "8"
  set mom_sys_coolant_code(OFF)                 "9"
  set mom_sys_rewind_code                       "30"
  set mom_sys_wcs_change_code                   "53"
#
  set mom_sys_spindle_ranges                    "4"
  set mom_sys_spindle_range_code(1)             "38"
  set mom_sys_spindle_range_code(2)             "39"
  set mom_sys_spindle_range_code(3)             "40"
  set mom_sys_spindle_range_code(4)             "41"
  set mom_sys_spindle_range_code(38)            "38"
  set mom_sys_spindle_range_code(39)            "39"
  set mom_sys_spindle_range_code(40)            "40"
  set mom_sys_spindle_range_code(41)            "41"

  set mom_sys_rewind_stop_code                  "%"
  set mom_sys_home_pos(0)                       "0"
  set mom_sys_home_pos(1)                       "0"
  set mom_sys_home_pos(2)                       "0"
  set mom_sys_zero                              "0"
  set mom_sys_opskip_block_leader               "/"
  set mom_sys_seqnum_start                      "1"
  set mom_sys_seqnum_incr                       "1"
  set mom_sys_seqnum_freq                       "1"
  set mom_sys_leader(N)                         "N"
  set mom_sys_contour_feed_mode(LINEAR)         "MMPM"
  set mom_sys_contour_feed_mode(ROTARY)         "MMPM"
  set mom_sys_contour_feed_mode(LINEAR_ROTARY)  "MMPM"
  set mom_sys_rapid_feed_mode(LINEAR)           "MMPM"
  set mom_sys_rapid_feed_mode(ROTARY)           "MMPM"
  set mom_sys_rapid_feed_mode(LINEAR_ROTARY)    "MMPM"
  set mom_sys_feed_param(IPM,format)            "Feed_IPM"
  set mom_sys_feed_param(FRN,format)            "Feed_INV"
  set mom_sys_feed_param(DPM,format)            "Feed_DPM"
  set mom_sys_feed_param(MMPM,format)           "Feed_MMPM"
  set mom_sys_feed_param(MMPR,format)           "Feed_MMPR"
  set mom_sys_cycle_feed_mode                   "MMPM"
  set mom_sys_control_out                       "("
  set mom_sys_control_in                        ")"

####### KINEMATIC VARIABLE DECLARATIONS ##############
  set mom_kin_coordinate_type                   "CARTESIAN"
  set mom_kin_arc_output_mode                   "FULL_CIRCLE" ; # FULL_CIRCLE  LINEAR QUADRANT
  set mom_kin_arc_valid_planes                  "XY" ;      # ANY XYZ XY YZ ZX
  set mom_kin_clamp_time                        "2.0"
  set mom_kin_linearization_flag                "F"
  set mom_kin_linearization_tol                 "0.01"
  set mom_kin_machine_resolution                "0.01"
  set mom_kin_machine_type                      "3_axis_mill"
  set mom_kin_max_arc_radius                    "12999.999"
  set mom_kin_max_dpm                           "100"
  set mom_kin_max_fpm                           "1000"
  set mom_kin_max_fpr                           "100"
  set mom_kin_max_frn                           "1000"
  set mom_kin_min_arc_length                    "0.025"
  set mom_kin_min_arc_radius                    "0.016"
  set mom_kin_min_dpm                           "0.0"
  set mom_kin_min_fpm                           "0.0"
  set mom_kin_min_fpr                           "0.0"
  set mom_kin_min_frn                           "0.0"
  set mom_kin_output_unit                       "MM"
  set mom_kin_pivot_gauge_offset                "0.0"
  set mom_kin_post_data_unit                    "MM"
  set mom_kin_rapid_feed_rate                   "1000.0"
  set mom_kin_tool_change_time                  "20.0"
  set mom_kin_x_axis_limit                      "20000" ; # 4000
  set mom_kin_y_axis_limit                      "6000" ; # 4000
  set mom_kin_z_axis_limit                      "100" ; # 3500
  set mom_kin_read_ahead_next_motion            "T"

####  Listing File variables
  set mom_sys_list_output                       "ON"
  set mom_sys_header_output                     "ON"
  set mom_sys_list_file_rows                    "120"
  set mom_sys_list_file_columns                 "250"
  set mom_sys_warning_output                    "ON"
  set mom_sys_group_output                      "OFF"
  set mom_sys_list_file_suffix                  "lpt"
  set mom_sys_output_file_suffix                "up"
  set mom_sys_commentary_output                 "ON"
  set mom_sys_commentary_list                   "x y z feed speed"

   set mom_sys_post_initialized 1
  }


############################################################################

#=============================================================
proc MOM_start_of_program { } {
#=============================================================
  global mom_logname mom_date is_from
  global mom_coolant_mode mom_coolant_status
  global mom_cutcom_mode mom_cutcom_status
  global mom_clamp_status mom_cycle_status
  global mom_spindle_status mom_cutcom_plane pb_start_of_program_flag
  global mom_cutcom_adjust_register mom_tool_adjust_register
  global mom_tool_length_adjust_register mom_length_comp_register
  global mom_flush_register
  global mom_wire_cutcom_status mom_wire_cutcom_adjust_register

    set pb_start_of_program_flag 0
    set mom_coolant_status UNDEFINED
    set mom_cutcom_status  UNDEFINED
    set mom_clamp_status   UNDEFINED
    set mom_cycle_status   UNDEFINED
    set mom_spindle_status UNDEFINED
    set mom_cutcom_plane   UNDEFINED

  catch {unset mom_coolant_mode}
  catch {unset mom_coolant_status}
  catch {unset mom_cutcom_mode}
  catch {unset mom_cutcom_status}

    catch {unset mom_cutcom_adjust_register}
    catch {unset mom_tool_adjust_register}
    catch {unset mom_tool_length_adjust_register}
    catch {unset mom_length_comp_register}
    catch {unset mom_flush_register}
    catch {unset mom_wire_cutcom_adjust_register}
    catch {unset mom_wire_cutcom_status }

    set is_from ""

    OPEN_files ; #open warning and listing files
    LIST_FILE_HEADER ; #list header in commentary listing

  global mom_sys_post_initialized
  if { $mom_sys_post_initialized > 1 } { return }


#************
uplevel #0 {


#=============================================================
proc MOM_sync {} {
#=============================================================
  if [llength [info commands PB_CMD_kin_handle_sync_event] ] {
    PB_CMD_kin_handle_sync_event
  }
}


#=============================================================
proc MOM_set_csys {} {
#=============================================================
  if [llength [info commands PB_CMD_kin_set_csys] ] {
    PB_CMD_kin_set_csys
  }
}


#=============================================================
proc MOM_msys {} {
#=============================================================
}


#=============================================================
proc MOM_end_of_program { } {
#=============================================================
# This procedure is executed at the end of the program after all the paths are traversed.
  global mom_part_name
  global mom_warning_info
  global mom_output_file_basename

  global mom_machine_time
  set str1 "    =[format "%.2f" $mom_machine_time ] "
  catch { set str2 [ outTime $mom_machine_time ] }
  MOM_output_to_listing_device "\n$str1  $str2"

  PB_end_of_program

  MOM_do_template end_of_program
  MOM_set_seq_off
  MOM_do_template rewind_end_of_program

#**** The following procedure lists the tool list with time in commentary data
   LIST_FILE_TRAILER

#**** The following procedure closes the warning and listing files
   CLOSE_files

  #    
  global ptp_file_name  mom_output_file_directory  mom_output_file_basename
  #set perf_file_name [ MOM_ask_unique_filename ]
  set perf_file_name ${mom_output_file_directory}${mom_output_file_basename}.prfl
  if {[file exists $perf_file_name]} {
  	MOM_remove_file $perf_file_name
  }

  MOM_close_output_file $ptp_file_name

  if { [llength [info commands perflplz]] } {
  	perflplz $ptp_file_name $perf_file_name
   } else {
        MOM_output_to_listing_device "\n     -   !\n  -   !. \n"
  }

}


  incr mom_sys_post_initialized

} ;# uplevel
#***********


}


#=============================================================
#____________________________________________________________
proc PB_begin_of_program { } {
#____________________________________________________________
  # "R1+8M91"
  # "G4X3000"
  # "M82"
  MOM_do_template plazreska_on
  global delay_time
  set delay_time 3.0
  MOM_do_template delay
  MOM_do_template plazreska_fixed
}


#____________________________________________________________
proc PB_end_of_program { } {
#____________________________________________________________
  # "R1+4M91"
  # "G4X1000"
  # "M82"
  MOM_do_template plazreska_off
  global delay_time
  set delay_time 1.0
  MOM_do_template delay
  MOM_do_template plazreska_fixed
}
#=============================================================


#=============================================================
proc PB_start_of_program { } {
#=============================================================
global  mom_warning_info
global  mom_output_file_basename
global  mom_logname  mom_date


   if { [llength [info commands PB_CMD_kin_start_of_program]] } {
      PB_CMD_kin_start_of_program
   }

  set mom_warning_info "\n   2P32M ()."
  MOM_output_to_listing_device $mom_warning_info  ;  # MOM_catch_warning ;

  set mom_warning_info "\n :\n"
  append mom_warning_info "\tG01 -  \n"
  append mom_warning_info "\tG17 -   (XY)\n"
  append mom_warning_info "\tG40 -     \n"
  append mom_warning_info "\tG91 -   \n"
  append mom_warning_info "\tM83 -  \n"
  append mom_warning_info "\tM94 -       \n"
  MOM_output_to_listing_device $mom_warning_info  ; #  MOM_catch_warning ;

  global mom_sys_rewind_stop_code
  set str "$mom_sys_rewind_stop_code"

  global partno_program
  if {[info exists partno_program]} {
    if {$partno_program != ""} { append str $partno_program }
  }

  MOM_set_seq_off
  MOM_output_literal "$str"
  MOM_set_seq_on

  global mom_output_mode
  set mom_output_mode  "ABSOLUTE" ;   # "ABSOLUTE", "INCREMENTAL"
  MOM_set_modes

  catch { PB_slowdn_load }
  MOM_suppress off G_slowdn
  MOM_force Once G_plane G_mode
  MOM_suppress always D G_cutcom
  MOM_suppress always G_slowdn
}


#=============================================================
proc PB_CMD_machine_mode { } {
#=============================================================
  global mom_output_mode mom_arc_mode mom_prev_machine_mode mom_machine_mode mom_feed_set_mode
  set mom_output_mode     	"INCREMENTAL"
  set mom_prev_machine_mode  	"MILL"
  set mom_machine_mode 		"MILL"
  set mom_arc_mode     		"CIRCULAR"
  set mom_feed_set_mode 	"MMPM"
}

#=============================================================
proc MOM_machine_mode {} {
#=============================================================
  catch {PB_CMD_machine_mode} errMes ; MOM_log_message "$errMes" ;
}


#=============================================================
proc MOM_start_of_group {} {
#=============================================================
  global mom_sys_group_output mom_group_name group_level ptp_file_name
  global mom_sequence_number mom_sequence_increment mom_sequence_frequency
  global mom_sys_ptp_output pb_start_of_program_flag

    if {![hiset group_level]} {set group_level 0 ; return}

    if {[hiset mom_sys_group_output]} {if {$mom_sys_group_output == "OFF"} {set group_level 0 ; return}}

    if {[hiset group_level]} {incr group_level} else {set group_level 1}
    if {$group_level > 1} {return}

    SEQNO_RESET ; #<4133654>
    MOM_reset_sequence $mom_sequence_number $mom_sequence_increment $mom_sequence_frequency

    if {[info exists ptp_file_name]} {
      MOM_close_output_file $ptp_file_name ; MOM_start_of_program
      if {$mom_sys_ptp_output == "ON"} {MOM_open_output_file $ptp_file_name }
    } else {
      MOM_start_of_program
    }

    PB_start_of_program ; set pb_start_of_program_flag 1
}


############## EVENT HANDLING SECTION ################

#=============================================================
proc MOM_start_of_path { } {
#=============================================================
  global pb_start_of_program_flag
  if {$pb_start_of_program_flag == 0} {
      PB_start_of_program ;
      set pb_start_of_program_flag 1
   }

  global mom_sys_in_operation
   set mom_sys_in_operation 1

  global first_linear_move ; set first_linear_move 0
   TOOL_SET MOM_start_of_path

   if [llength [info commands PB_CMD_kin_start_of_path] ] {
      PB_CMD_kin_start_of_path
   }

}


#=============================================================
proc MOM_before_motion { } {
#=============================================================
  global mom_motion_event mom_motion_type  mom_current_motion

  FEEDRATE_SET

  global g_plane  ;  set g_plane [CHECK_PLANE]

    switch $mom_motion_type {
      ENGAGE   {PB_engage_move}
      APPROACH {PB_approach_move}
      FIRSTCUT {PB_first_cut}
      RETURN   {PB_return_move}
    }

    if { [llength [info commands PB_CMD_kin_before_motion]] } { PB_CMD_kin_before_motion }
    if { [llength [info commands PB_CMD_before_motion]] }     { PB_CMD_before_motion }

}


#=============================================================
proc MOM_from_move { } {
#=============================================================
# This procedure is called for a FROM statement
    catch { RAPID_SET ; }  errMes ; MOM_log_message "$errMes" ;
    MOM_do_template from
}


#=============================================================
proc MOM_initial_move { } {
#=============================================================
# This procedure is executed for the initial move of each operation.  It
# assumes the tool is moving from a safe position at rapid to the start of
# the operation.
   global mom_motion_event  mom_motion_type
   global mom_programmed_feed_rate  mom_feed_rate  mom_kin_rapid_feed_rate
   if { [EQ_is_equal $mom_programmed_feed_rate 0.0] || [EQ_is_ge $mom_feed_rate $mom_kin_rapid_feed_rate ] } {
      MOM_rapid_move
   } else {
        if {$mom_motion_event == "rapid_move"} { MOM_rapid_move; return ;  }
  	if {$mom_motion_type == "RAPID"} { MOM_rapid_move ; return ; }
      MOM_linear_move
   }

  PB_begin_of_program

}


#=============================================================
proc MOM_first_move { } {
#=============================================================
  catch { COOLANT_SET ; SPINDLE_SET ; RAPID_SET }  errMes ; MOM_log_message "$errMes" ;
  global  mom_motion_event
  catch {MOM_$mom_motion_event} errMes ; MOM_log_message "$errMes" ;
}


#=============================================================
proc MOM_gohome_move { } {
#=============================================================
   MOM_do_template gohome
}


#=============================================================
proc MOM_end_of_path { } {
#=============================================================
# This procedure is executed at the end of a path.
   if [llength [info commands PB_CMD_kin_end_of_path] ] {
      PB_CMD_kin_end_of_path
   }

   global mom_sys_in_operation
   set mom_sys_in_operation 0
}



#=============================================================
proc MOM_spindle_rpm { } {
#=============================================================
   global mom_spindle_text   mom_spindle_direction
   SPINDLE_SET
}


#=============================================================
proc MOM_spindle_css { } {
#=============================================================
# This procedure is executed when the Spindle command is activated SFM/SMM mode.
  global mom_spindle_status mom_spindle_mode
  set mom_spindle_status $mom_spindle_mode

  if {$mom_spindle_mode == "SFM" || $mom_spindle_mode == "SMM"} {
     SPINDLE_SET
  }

}

#=============================================================
proc MOM_spindle_off { } {
#=============================================================
   global mom_spindle_text   mom_spindle_direction
}


#=============================================================
proc MOM_coolant_on { } {
#=============================================================
# This procedure is executed when the Coolant command is activated.
   COOLANT_SET
}


#=============================================================
proc MOM_coolant_off { } {
#=============================================================
# This procedure is executed when the Coolant command is deactivated.

}


#=============================================================
proc MOM_cutcom_on { } {
#=============================================================
# This procedure is executed when the Cutcom command is activated.
  global mom_cutcom_status  mom_cutcom_mode ;
  set mom_cutcom_status $mom_cutcom_mode
  MOM_force once G_cutcom D
  ;#
  global flagCutcom_begin ; 	set flagCutcom_begin 	1
  ;#
  global g_plane ; set g_plane [CHECK_PLANE]
  MOM_do_template plane
#  MOM_do_template cutcom_on
}


#=============================================================
proc MOM_cutcom_off { } {
#=============================================================
# This procedure is executed when the Cutcom command is deactivated.
 global mom_cutcom_status  mom_cutcom_mode  mom_sys_cutcom_code
 MOM_force once G_cutcom
 MOM_force off D
 MOM_do_template cutcom_off
 catch {unset mom_cutcom_mode}
 ;#
 global flagCutcom_begin ; set flagCutcom_begin  0
 ;#
}


proc  MOM_wire_cutcom {} {
#_______________________________________________________________________________
# This procedure is executed when the Cutcom command is activated.
#_______________________________________________________________________________
    global mom_wire_cutcom_mode
    global mom_wire_cutcom_status
    if {$mom_wire_cutcom_status == "ON"} {
        set mom_wire_cutcom_status $mom_wire_cutcom_mode
        MOM_force once G_cutcom
    }
}

#_______________________________________________________________________________
proc  MOM_thread_wire {} {
#_______________________________________________________________________________
}

#_______________________________________________________________________________
proc  MOM_cut_wire {} {
#_______________________________________________________________________________
    MOM_do_template cut_wire
}


#=============================================================
proc MOM_linear_move { } {
#=============================================================
  global mom_motion_event  mom_motion_type

  global feed_mode mom_feed_rate mom_kin_rapid_feed_rate
  if { $feed_mode == "IPM" || $feed_mode == "MMPM" } {
      if { [EQ_is_ge $mom_feed_rate $mom_kin_rapid_feed_rate] } {
         MOM_rapid_move
         return
      }
   }
  if {$mom_motion_type == "RAPID"} { MOM_rapid_move ; return ; }

  global mom_cutcom_mode  mom_cutcom_status
  if {[info exists mom_cutcom_mode]} {  set mom_cutcom_status $mom_cutcom_mode ; }

  catch { PB_slowdn_move }

  set str [MOM_do_template linear_move CREATE]

 global flagCutcom_begin
 if {$flagCutcom_begin==1} {

   set flG  0
   set flG [regexp -nocase -- {(G)(41)+|(G)(42)+} $str ]

   global mom_mill_spindle_axis
   global g_plane
   set flvar 0
   switch $g_plane {
     "17" { ;# XY
     	   set flvar [regexp -nocase -- {(Z)+} $str ];
     	  }
     "18" { ;# XZ
 	   set flvar [regexp -nocase -- {(Y)+} $str ];
     	  }
     "19" { ;# YZ
     	   set flvar [regexp -nocase -- {(X)+} $str ];
      	  }
    }

   set st [expr $flvar+$flG ]
   if {$st==2} {
   	set var0 ""
   	set fl [regsub -nocase -- {(G)(41)+|(G)(42)+}  $str "" var0 ]
   	set str $var0
   	MOM_force once G_cutcom
   	global mom_warning_info mom_seqnum
   	set nm [format "%.0f" $mom_seqnum ]
   	set mom_warning_info "!:   (G41|G42)     \{$nm\}    ."
   	append mom_warning_info "\n\t !  (G41|G42)         !"
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
    }

  }

  MOM_output_literal "$str"

}


#=============================================================
proc MOM_circular_move { } {
#==================================================================
# This procedure is executed for each circular move. It gets called after
# the circle data are loaded (end point and center).
  CIRCLE_SET
  global g_plane ;  set g_plane [CHECK_PLANE]

  global mom_cutcom_mode  mom_cutcom_status
  if {[info exists mom_cutcom_mode]} {  set mom_cutcom_status $mom_cutcom_mode ; }

  switch $g_plane {
        "17" { MOM_suppress once K Z; MOM_force once  I J X Y; }
        "18" { MOM_suppress once J Y; MOM_force once  I K X Z; }
        "19" { MOM_suppress once I X; MOM_force once  J K Y Z; }
  }

  if {$g_plane != "NONE"}  { MOM_do_template plane }

  catch { PB_slowdn_move }
  MOM_do_template circular_move

}


#=============================================================
proc MOM_rapid_move { } {
#=============================================================
# This procedure is executed for each rapid move. It gets called after
# the positioning varables, position and tool axis (X,Z,TAX,TAY,TAZ) are loaded.
  global rapid_spindle_inhibit rapid_traverse_inhibit
  global spindle_first is_from
  global mom_cycle_spindle_axis traverse_axis1 traverse_axis2
  global mom_motion_event

   set aa(0) X ; set aa(1) Y ; set aa(2) Z
   RAPID_SET
   catch { PB_slowdn_move }
   MOM_do_template rapid_traverse

}


#=============================================================
proc PB_auto_tool_change { } {
#=============================================================
  global mom_tool_change_type mom_manual_tool_change

}


#=============================================================
proc PB_manual_tool_change { } {
#=============================================================
  MOM_do_template manual_tool_change
}


#=============================================================
proc MOM_load_tool { } {
#=============================================================
   global mom_tool_change_type mom_manual_tool_change
}


#=============================================================
proc MOM_first_tool { } {
#=============================================================
  global mom_tool_change_type mom_manual_tool_change
  if {[info exists mom_tool_change_type]} {
      switch $mom_tool_change_type {
         MANUAL { PB_manual_tool_change }
         AUTO   { PB_auto_tool_change }
      }
   } elseif {[info exists mom_manual_tool_change]} {
      if {$mom_manual_tool_change == "TRUE"} {
         PB_manual_tool_change
      }
   }
}


#=============================================================
proc MOM_tool_change { } {
#=============================================================
  global mom_tool_change_type mom_manual_tool_change
  if {[info exists mom_tool_change_type]} {
      switch $mom_tool_change_type {
         MANUAL { PB_manual_tool_change }
         AUTO   { PB_auto_tool_change }
      }
   } elseif {[info exists mom_manual_tool_change]} {
      if {$mom_manual_tool_change == "TRUE"} {
         PB_manual_tool_change
      }
   }
}


#=============================================================
proc MOM_tool_preselect { } {
#=============================================================
  global mom_tool_preselect_number mom_tool_number mom_next_tool_number
}


#=============================================================
proc MOM_length_compensation { } {
#=============================================================
  global  mom_tool_text  mom_tool_adjust_register
  global  mom_length_comp_register   mom_length_comp_register_text
}


#=============================================================
proc MOM_set_modes { } {
#=============================================================
# This procedure is executed for the Set Mode command.
   MODES_SET
}


#=============================================================
proc MOM_delay { } {
#=============================================================
# This procedure is executed when the Delay command is activated.
  global mom_sys_delay_param mom_delay_value
  global mom_delay_revs mom_delay_mode delay_time
  global mom_warning_info

   # post builder provided format for the current mode:
    if {[info exists mom_sys_delay_param(${mom_delay_mode},format)] != 0} {
      MOM_set_address_format dwell $mom_sys_delay_param(${mom_delay_mode},format)
    }

    switch $mom_delay_mode {
      SECONDS {set delay_time $mom_delay_value}
      default {
         set delay_time $mom_delay_revs ;
         set mom_warning_info "WARNING:      . !"
         MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
      }
    }

   MOM_force_block ONCE delay
   MOM_do_template delay
}


#=============================================================
proc MOM_opstop { } {
#=============================================================
   MOM_do_template opstop
}


#=============================================================
proc MOM_auxfun { } {
#=============================================================
 global mom_auxfun_text  mom_auxfun_text_defined
 MOM_suppress once Text
 if {[info exists  mom_auxfun_text]} {
    if {$mom_auxfun_text!=""} { MOM_force  once  Text }
   }
 MOM_do_template auxfun
}


#=============================================================
proc MOM_prefun { } {
#=============================================================
 global mom_prefun_text  mom_prefun_text_defined
 MOM_suppress once Text
 if {[info exists mom_prefun_text]} {
    if {$mom_prefun_text!=""} { MOM_force  once  Text }
   }
 MOM_do_template prefun
}


#=============================================================
proc MOM_stop { } {
#=============================================================
   MOM_do_template stop
}


#=============================================================
proc MOM_text {} {
#=============================================================
# This procedure is executed when the Text command is activated.

  global mom_user_defined_text mom_record_text mom_record_fields mom_field_count
  global mom_Instruction
  global mom_sys_control_out mom_sys_control_in
  global mom_operator_message mom_operator_message_defined
  global mom_pprint_defined mom_pprint
  global mom_warning_info

  switch [string toupper $mom_record_fields(0)] {
   "SET"  { ; }
  "PPRINT" {
           set mom_pprint_defined 1
           set mom_pprint $mom_record_text
           MOM_pprint
           }
  "DISPLY" {
           set mom_operator_message_defined 1
           set mom_operator_message $mom_record_text
           MOM_operator_message
          }
  "INSERT" {
           if {[info exists mom_record_fields(1)]}  {
              set mom_Instruction [string toupper $mom_record_text ] ; #$mom_record_fields(1)] ;
              MOM_insert
              set mom_warning_info "WARNING:    'INSERT/$mom_Instruction' -  \n"
              MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
           }
         }
  "PARTNO" { ; #   ()
         }
  "REWIND" { ;  }
  "MACALL" { ; #  
          }
  "MACND" { ; #  
           }
  "MACST" {  ; #  () 
           }
  "STLOOP" { ; #   
          }
  "NDLOOP" { ; #   
           }
  "SAFETY" { ; #       
         }
  "SELECT" { ; #  
          }
  "SLOWDN" {  ; #    
  		catch { PB_slowdn }
          }
  "TIME" { ; }
  "ZERO" {
           global  mom_work_coordinate_number
           set mom_work_coordinate_number $mom_record_fields(1)
           MOM_zero
         }
 default {
            set mom_warning_info "WARNING:   !($mom_user_defined_text)"
            MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
            MOM_output_literal $mom_user_defined_text
         }
  }
}


#=============================================================
proc  MOM_clamp {} {
#=============================================================
#     G      .
 global mom_clamp_status mom_clamp_axis mom_clamp_text
 global mom_warning_info
 set mom_warning_info "WARNING:  \[clamp\]  "
 MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
}


#=============================================================
proc  MOM_pprint {} {
#=============================================================
#___ This procedure is executed when the Text command is activated.
 global mom_pprint ;
 global mom_warning_info

 if {[info exists mom_pprint]} {
  if {$mom_pprint!=""} {
     MOM_output_literal "($mom_pprint)"
   }
 }

}


#=============================================================
proc  MOM_operator_message {} {
#=============================================================
#__This procedure is executed when the Operator Message command is activated.
 global mom_operator_message  mom_operator_message_defined
 global mom_warning_info

  if {[info exists mom_operator_message]} {
    if {$mom_operator_message!=""} {
     MOM_output_literal "($mom_operator_message)"
    }
  }

}


#=============================================================
proc  MOM_zero {} {
#=============================================================
#     G      .
#         Fanuc.
#   G   ZERO/CHECK, ZERO/ON, ZERO/OFF, ZERO/THRU,   G   ZERO/n.
 global mom_sys_wcs_change_code mom_work_coordinate_number

}


#=============================================================
proc MOM_sequence_number { } {
#=============================================================
   SEQNO_SET
}


#=============================================================
proc MOM_origin {} {
#=============================================================
  global mom_origin_point ;
  global mom_warning_info ;
  set mom_warning_info "WARNING:   X, Y, Z -  "
  MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
}


##############################################################

#=============================================================
proc PB_approach_move { } {
#=============================================================
}


#=============================================================
proc PB_engage_move { } {
#=============================================================
}


#=============================================================
proc PB_first_cut { } {
#=============================================================
}


#=============================================================
proc PB_return_move { } {
#=============================================================
}

#=============================================================
proc MOM_cycle_off { } {
#=============================================================
  global cycle_name
  MOM_force once G_motion F
  set cycle_name OFF

  global mom_warning_info
  set mom_warning_info "\nWARNING:    \n     Point-to-Point\n"
  MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
  MOM_abort "$mom_warning_info"

}

#=============================================================
proc MOM_cycle_plane_change { } {
#=============================================================
  global cycle_init_flag
  set cycle_init_flag TRUE

}

#####################################################################
########################
# Redefine FEEDRATE_SET -     MMPM ;   - 
########################
if [llength [info commands ugpost_FEEDRATE_SET] ] {
   rename ugpost_FEEDRATE_SET ""
}

if [llength [info commands FEEDRATE_SET] ] {
   rename FEEDRATE_SET ugpost_FEEDRATE_SET
} else {
   proc ugpost_FEEDRATE_SET {} {}
}


#=============================================================
proc FEEDRATE_SET {} {
#=============================================================
   if [llength [info commands PB_CMD_kin_feedrate_set] ] {
      PB_CMD_kin_feedrate_set
   } else {
      ugpost_FEEDRATE_SET
   }
}

proc ASK_FEEDRATE_FPM {} {
#_______________________________________________________________________________
# returns feed rate IN or MM per min
#_______________________________________________________________________________
  global mom_feed_rate

  if {[hiset mom_feed_rate]} {
    global mom_kin_rapid_feed_rate
    if {$mom_feed_rate>=$mom_kin_rapid_feed_rate} {
  	set mom_feed_rate $mom_kin_rapid_feed_rate
    }
    return $mom_feed_rate
  } else {
    set mom_warning_info "FEED RATE UNDEFINED" ; MOM_catch_warning ; return 0.0
  }
}


set feed 0.0 ; set feed_mode MMPM
#=============================================================
proc PB_CMD_kin_feedrate_set { } {
#=============================================================
# This procedure supercedes the functionalites provided by the
# FEEDRATE_SET in ugpost_base.tcl.  Post Builder automatically
# generates proper call sequences to this procedure in the
# Event handlers.
#
# This procedure must be used in conjunction with ugpost_base.tcl.
#
  global   feed com_feed_rate
  global   mom_feed_rate_output_mode super_feed_mode feed_mode
  global   mom_cycle_feed_rate_mode mom_cycle_feed_rate
  global   mom_cycle_feed_rate_per_rev
  global   mom_motion_type
  global   mom_warning_info
  global   Feed_IPM Feed_IPR Feed_MMPM Feed_MMPR Feed_INV
  global   mom_sys_feed_param
  global   mom_sys_cycle_feed_mode

  set super_feed_mode $mom_feed_rate_output_mode

  set f_pm [ASK_FEEDRATE_FPM] ; set f_pr [ASK_FEEDRATE_FPR]

  switch $mom_motion_type {

    CYCLE {
      if [info exists mom_sys_cycle_feed_mode] {
         if { $mom_sys_cycle_feed_mode != "Auto" } {
            set mom_cycle_feed_rate_mode $mom_sys_cycle_feed_mode
         }
      }
      if {[hiset mom_cycle_feed_rate_mode]} { set super_feed_mode $mom_cycle_feed_rate_mode }
      if {[hiset mom_cycle_feed_rate]} { set f_pm $mom_cycle_feed_rate }
      if {[hiset mom_cycle_feed_rate_per_rev]} { set f_pr $mom_cycle_feed_rate_per_rev }
    }

    FROM -
    RETRACT -
    RETURN -
    LIFT -
    TRAVERSAL -
    GOHOME  -
    GOHOME_DEFAULT -
    RAPID {
      SUPER_FEED_MODE_SET RAPID
    }

    default {
      if {[EQ_is_zero $f_pm] && [EQ_is_zero $f_pr]} {
        SUPER_FEED_MODE_SET RAPID
      } else {
        SUPER_FEED_MODE_SET CONTOUR
      }
    }
  }

  set feed_mode $super_feed_mode

 # Adjust feedrate format per Post output unit again.
  global mom_kin_output_unit
  if { $mom_kin_output_unit == "IN" } {
     switch $feed_mode {
       MMPM {
         set feed_mode "IPM"
         CATCH_WARNING "Feedrate mode MMPM changed to IPM"
       }
       MMPR {
         set feed_mode "IPR"
         CATCH_WARNING "Feedrate mode MMPR changed to IPR"
       }
     }
    CATCH_WARNING " 2P32     - "
    MOM_abort "\n\n\t 2P32     - \n\n"
  } else {
     switch $feed_mode {
       IPM {
         set feed_mode "MMPM"
         CATCH_WARNING "Feedrate mode IPM changed to MMPM .  2P32      IPM"
       }
       IPR {
         set feed_mode "MMPR"
         CATCH_WARNING "Feedrate mode IPR changed to MMPR .  2P32      IPR"
       }
     }
  }

 global  mom_path_name

  switch $feed_mode {
    IPM     -
    MMPM    { set feed $f_pm }
    IPR     -
    MMPR    {
    	        CATCH_WARNING " 2P32   c   - MMPR. Operation $mom_path_name \nFeedrate mode MMPR changed to MMPM"
    	        set feed $f_pm
    	        set feed_mode "MMPM"
     }
    DPM     {
    	#returns feed rate in degrees per min
    	CATCH_WARNING " 2P32   c   - DPM. Operation $mom_path_name "
    	set feed [PB_CMD_FEEDRATE_DPM]
     }
    FRN     -
    INVERSE {
    	# returns feed rate number in inverse time
    	CATCH_WARNING " 2P32   c   - FRN , INVERSE . Operation $mom_path_name "
    	set feed [PB_CMD_FEEDRATE_NUMBER]
     }
    default { set mom_warning_info "INVALID FEED RATE MODE" ; MOM_catch_warning ; return }
  }


 # Post Builder provided format for the current mode:
  if [info exists mom_sys_feed_param(${feed_mode},format)] {
    MOM_set_address_format F $mom_sys_feed_param(${feed_mode},format)
  } else {
    switch $feed_mode {
      IPM     -
      MMPM    -
      IPR     -
      MMPR    -
      DPM     -
      FRN     { MOM_set_address_format F Feed_${feed_mode} }
      INVERSE { MOM_set_address_format F Feed_INV }
    }
  }

 # Commentary output
  set com_feed_rate $f_pm


 # Execute user's commnad, if any.
  if [llength [info commands "PB_CMD_FEEDRATE_SET"]] {
     PB_CMD_FEEDRATE_SET
  }
}

####################################################################

#***************************
# Source in user's tcl file.
#***************************
 set user_tcl_file "${cam_post_dir}PERFLPLZ.TCL"
 if { [file exists $user_tcl_file] } {
    source $user_tcl_file
 }


#***************************
# Source in user's tcl file.
#***************************
 set user_tcl_file "${cam_post_dir}2p32m_user.tcl"
 if { [file exists $user_tcl_file] } {
    source $user_tcl_file
 }
